﻿package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.FullScreenEvent;
	import flash.geom.Matrix;
	import flash.geom.Point;

	public class Liaer extends Sprite
	{
		private var background:Bitmap;
		private var bmd:BitmapData;
		private var colors:Array = ['0xCC99CC','0x99CCFF','0x9966FF'];
		private var canevas:Sprite = new Sprite();
		private var circles:Array;
		public function Liaer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);
		}
		private function fullhandler(e:FullScreenEvent):void
		{
			setup();
		}
		private function addedHandler(e:Event):void
		{
			stage.addEventListener(FullScreenEvent.FULL_SCREEN,fullhandler);
			setup();
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function setup():void
		{
			bmd = new BitmapData(stage.stageWidth,stage.stageHeight,false,0x000000);
			background = new Bitmap(bmd);
			background.smoothing = true;
			addChild(background);
			buildModels(20);
		}
		private function buildModels(val:uint):void
		{
			circles = [];
			for(var i:uint = 0;i<val;i++){
				circles.push({'r':(Math.random()*180),'centerX':(stage.stageWidth/2),'centerY':(stage.stageHeight/2),'angle':Math.random()*180,'color':colors[Math.round(Math.random()*(colors.length-1))],'dec':Math.random()*180});
			}
		}
		private function enterHandler(e:Event):void
		{
			for(var j:uint = 0;j<circles.length;j++){
				canevas.graphics.clear();
				for(var i:uint = 0;i<360;i++){
					circles[j].r+=0.0001;
					canevas.graphics.lineStyle(2,circles[j].color,i/10000);
					(i==0)?canevas.graphics.moveTo(Math.cos((i+circles[j].dec)*Math.PI/90)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/90)*circles[j].r + circles[j].centerY):canevas.graphics.lineTo(Math.cos((i+circles[j].dec)*Math.PI/180)*circles[j].r + circles[j].centerX,Math.sin((i+circles[j].dec)*Math.PI/180)*circles[j].r+ circles[j].centerY);
				}
				bmd.draw(canevas);
				circles[j].centerX+=Math.cos(circles[j].angle*Math.PI/90)*Math.random();
				circles[j].centerY+=Math.sin(circles[j].angle*Math.PI/90)*Math.random();
				circles[j].dec+=Math.cos(circles[j].angle);
			}
		}
	}
}